import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Diese Klasse stellt den Marienkfer Kara zur Verfgung. Bisher kann er nur das, was alle 
 * Tiere knnen (geerbte Methoden), nmlich vorwrts bewegen, drehen, schauen, ob ein Objekt 
 * (Baum, Pilz oder Kleeblatt) in der Nhe ist und es ggf. fressen (aufnehmen) oder ein solches
 * Objekt ablegen.
 * 
 * Jetzt kann Kara schon einfach vorwrts laufen und sich einfach drehen.
 * 
 * Jetzt erkennt Kara, dass er auf einem Kleeblatt steht.
 * 
 * Jetzt kann Kara Kleebltter aufnehmen und wieder hinlegen.  
 * 
 * Jetzt kann Kara Bume vor ihm und neben ihm erkennen.    
 * 
 * @author Daniel Garmann
 * @version 26.08.2009
 */
public class Kara  extends Tier
{
    /**
     * Act - Hier muss nun das konkrete Verhalten des Marienkfers implementiert werden.
     * Das Verhalten wird im Zuge des Workshops stets komplexer.
     */
    public void act() 
    {
        // Kara lsst sich mit der Tastatur steuern, so dass er alle Kleebltter einfangen kann. Auf Pilzen stirbt Kara.
        if (Greenfoot.isKeyDown("left")) {
            turnLeft();
        }
        if (Greenfoot.isKeyDown("right")) {
            turnRight();
        }
        if (!treeFront()) {
            move();
        }
        if (onLeaf()) {
            removeLeaf();
        }
        if (onMushroom()) {
            Greenfoot.stop();
        }
    }  
    
    /**
     * Kara bewegt sich genau ein Zelle mit 30 Pixeln vorwrts.
     */         
    public void move() {
        this.move(30);
    }
    
    /**
     * Kara dreht sich 90 links herum
     */         
    public void turnLeft() {
        this.turn(90);
    }
    
    /**
     * Kara dreht sich 90 rechts herum.
     */         
    public void turnRight() {
        this.turn(270);
    }
      
    /**
     * Kara schaut nach, ob er sich auf einem Kleeblatt befindet.
     * @return true, falls Kara auf einem Kleeblatt steht, andernfalls false     
     */         
    public boolean onLeaf() {
        if (this.canSee(Leaf.class)) {
            return true;
        } else {
            return false;
        }
    }
    
    /**
     * Kara entfernt ein unter ihm liegendes Kleeblatt, falls ein solches exisitert.
     */         
    public void removeLeaf() {
        if (onLeaf()) {
            this.eat(Leaf.class);
        }
    }
    
    /**
     * Kara legt ein neues Kleeblatt an die Position, auf der er sich befindet.
     */         
    public void putLeaf() {
        put(Leaf.class);       
    }
    
    
    /**
     * Kara schaut nach, ob sich ein Baum vor ihm befindet.
     * @return true, falls Kara vor einem Baum steht, andernfalls false     
     */         
    public boolean treeFront() {
        move();
        boolean result;
        if (canSee(Tree.class)) {
            result = true;
        } else {
            result = false;
        }
        turn(180);
        move();
        turn(180); 
        return result;
    }
 
    /**
     * Kara schaut nach, ob sich ein Baum links von ihm befindet.
     * @return true, falls links neben Kara ein Baum steht, andernfalls false     
     */         
    public boolean treeLeft() {
        turnLeft();
        boolean result = treeFront();
        turnRight();
        return result;
    }

    /**
     * Kara schaut nach, ob sich ein Baum rechts von ihm befindet.
     * @return true, falls rechts neben Kara ein Baum steht, andernfalls false     
     */         
    public boolean treeRight() {
        turnRight();
        boolean result = treeFront();
        turnLeft();
        return result;
    }
   
    /**
     * Kara schaut nach, ob er sich auf einem Pilz befindet.
     * @return true, falls Kara auf einem Pilz steht, andernfalls false     
     */         
    public boolean onMushroom() {
        if (this.canSee(Mushroom.class)) {
            return true;
        } else {
            return false;
        }
    }
        
}
