import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Die Klasse Wiese beschreibt den Bauplan für eine Welt, in der Kara leben kann.
 * 
 * @author Daniel Garmann
 * @version 26.08.2009
 */
public class Wiese  extends World
{   
    private static final int block = 30; // Groeße eines einzelnen Feldes
    private static final int size = 10;  // Anzahl der Felder

    /**
     * Constructor für Objekte der Klasse Wiese.
     * 
     */
    public Wiese()
    {    
        // Erzeugt eine neue Welt mit size x size Zellen mit einer Größe von block x block Pixeln pro Zelle.
        super(block*size, block*size, 1); 

        for (int i = 0; i < 5; i++) {
            Tree tree = new Tree();
            this.addObject(tree, Greenfoot.getRandomNumber(size)*block+block/2, Greenfoot.getRandomNumber(size)*block+block/2);
        }

        for (int i = 0; i < 20; i++) {
            Leaf leaf = new Leaf();
            this.addObject(leaf, Greenfoot.getRandomNumber(size)*block+block/2, Greenfoot.getRandomNumber(size)*block+block/2);
        }

        for (int i = 0; i < 5; i++) {
            Mushroom mushroom = new Mushroom();
            this.addObject(mushroom, Greenfoot.getRandomNumber(size)*block+block/2, Greenfoot.getRandomNumber(size)*block+block/2);
        }
        
        Kara kara = new Kara();        
        this.addObject(kara,(size/2)*block+block/2,(size/2) * block+block/2);

        while (kara.onLeaf() || kara.onMushroom()) {
            kara.setLocation(Greenfoot.getRandomNumber(size)*block+block/2, Greenfoot.getRandomNumber(size)*block+block/2);
        }
        
        Frog frog = new Frog();
        
        this.addObject(frog,(size/4)*block+block/4,(size/4) * block+block/4);
    }
}
